/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.116 by edhill, Thu Jan 6 15:32:16 2005 UTC revision 1.166 by jmc, Mon Oct 29 20:47:42 2007 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 122  EOF Line 130  EOF
130        stop        stop
131        end        end
132  EOF  EOF
133      test -f Makefile  &&  mv -f Makefile Makefile.bak      test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
134      cat <<EOF >> Makefile      cat <<EOF >> $MAKEFILE
135  .SUFFIXES:  .SUFFIXES:
136  .SUFFIXES: .$tfs .F  .SUFFIXES: .$tfs .F
137  .F.$tfs:  .F.$tfs:
# Line 148  EOF Line 156  EOF
156              return              return
157          fi          fi
158      fi      fi
159      rm -f genmake_hello.* Makefile      rm -f genmake_hello.* $MAKEFILE
160      test -f Makefile  &&  mv -f Makefile.bak Makefile      test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
161    
162      #  If we make it here, use the extensions      #  If we make it here, use the extensions
163      FS=$tfs      FS=$tfs
# Line 181  look_for_makedepend()  { Line 189  look_for_makedepend()  {
189      if test "x${MAKEDEPEND}" = x ; then      if test "x${MAKEDEPEND}" = x ; then
190          which makedepend > /dev/null 2>&1          which makedepend > /dev/null 2>&1
191          RV0=$?          RV0=$?
192            test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
193            #  echo 'MAKEFILE="'$MAKEFILE'"'
194            cat <<EOF >> $MAKEFILE
195    #   THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196    #
197    #   Some "makedepend" implementations will die if they cannot
198    #   find a Makefile -- so this file is here to gives them an
199    #   empty one to find and parse.
200    EOF
201          cat <<EOF >> genmake_tc.f          cat <<EOF >> genmake_tc.f
202        program test        program test
203        write(*,*) 'test'        write(*,*) 'test'
# Line 189  look_for_makedepend()  { Line 206  look_for_makedepend()  {
206  EOF  EOF
207          makedepend genmake_tc.f > /dev/null 2>&1          makedepend genmake_tc.f > /dev/null 2>&1
208          RV1=$?          RV1=$?
209            test -f $MAKEFILE  &&  rm -f $MAKEFILE
210            test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
211          if test "x${RV0}${RV1}" = x00 ; then          if test "x${RV0}${RV1}" = x00 ; then
212              MAKEDEPEND=makedepend              MAKEDEPEND=makedepend
213          else          else
# Line 237  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 271  find_possible_configs()  { Line 325  find_possible_configs()  {
325    
326      #================================================================      #================================================================
327      #  look for possible C compilers      #  look for possible C compilers
328      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      p_CC=      p_CC=
330      for c in $tmp ; do      for c in $tmp ; do
331          rm -f ./genmake_hello.c  ./genmake_hello          rm -f ./genmake_hello.c  ./genmake_hello
# Line 310  EOF Line 364  EOF
364    
365      #================================================================      #================================================================
366      #  look for possible FORTRAN compilers      #  look for possible FORTRAN compilers
367      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 342  EOF Line 396  EOF
396      else      else
397          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
398          echo "   "$p_FC          echo "   "$p_FC
399          if test "x$FC" = x ; then      fi
400              FC=`echo $p_FC | $AWK '{print $1}'`  
401              echo "  Setting FORTRAN compiler to: "$FC      #  Use the first of the compilers found in the current PATH
402          fi      #  that has a correctly-named optfile
403        if test "x$OPTFILE" = x  -a  "x$FC" = x ; then
404            for i in $p_FC ; do
405                OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406                if test -r $OPTFILE ; then
407                    echo "  Setting OPTFILE to: "$OPTFILE
408                    break
409                fi
410            done
411      fi      fi
412    
413      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
# Line 516  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587        -ts | --ts
588              Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
609      -mpi=PATH | --mpi=PATH      -mpi=PATH | --mpi=PATH
# Line 523  Usage: "$0" [OPTIONS] Line 611  Usage: "$0" [OPTIONS]
611            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -es | --es | -embed-source | --embed-source
615              Embed a tarball containing the full source code
616              (including the Makefile, etc.) used to build the
617              executable [off by default]
618    
619      -bash NAME      -bash NAME
620            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
621    
# Line 581  WARNING: Please contact <MITgcm-support@ Line 674  WARNING: Please contact <MITgcm-support@
674  EOF  EOF
675          return 1          return 1
676      fi      fi
677      cat > genmake_tcomp.f <<EOF      cat > genmake_tcomp.$FS <<EOF
678        subroutine tcall( string )        subroutine tcall( string )
679        character*(*) string        character*(*) string
680        call tsub( string )        call tsub( string )
681        end        end
682  EOF  EOF
683      $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
684      RETVAL=$?      RETVAL=$?
685      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
686          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 653  void FC_NAMEMANGLE(cloc) ( double *curti Line 746  void FC_NAMEMANGLE(cloc) ( double *curti
746   *curtim = *curtim/1.E6;   *curtim = *curtim/1.E6;
747  }  }
748  EOF  EOF
749      make genmake_tc_1.o >> genmake_tc.log 2>&1      make genmake_tc_1.o >> genmake_warnings 2>&1
750      RET_C=$?      RET_C=$?
751      cat <<EOF > genmake_tc_2.f      cat <<EOF > genmake_tc_2.$FS
752        program hello        program hello
753        Real*8 wtime        REAL*8 wtime
754        external cloc        external cloc
755        call cloc(wtime)        call cloc(wtime)
756        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
757        end program hello        end
758  EOF  EOF
759      $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1      COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
760        echo $COMM >> genmake_warnings
761        $COMM >> genmake_warnings 2>&1
762      RET_F=$?      RET_F=$?
763      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
764      RETVAL=$?      RETVAL=$?
765      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
766          HAVE_CLOC=t          HAVE_CLOC=t
# Line 675  EOF Line 770  EOF
770  }  }
771    
772    
773    check_HAVE_SIGREG()  {
774        if test ! "x$HAVE_SIGREG" = x ; then
775            return
776        fi
777        get_fortran_c_namemangling
778        cat <<EOF > genmake_tc_1.c
779    $FC_NAMEMANGLE
780    #include <stdlib.h>
781    #include <stdio.h>
782    #include <signal.h>
783    #include <errno.h>
784    #include <ucontext.h>
785    
786    int * ip;
787    
788    static void killhandler(
789        unsigned int sn, siginfo_t  si, struct ucontext *sc )
790    {
791        *ip = *ip + 1;
792        return;
793    }
794    
795    void FC_NAMEMANGLE(sigreg) (int * aip)
796    {
797        struct sigaction s;
798        ip = aip;
799        s.sa_flags = SA_SIGINFO;
800        s.sa_sigaction = (void *)killhandler;
801        if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
802            printf("Sigaction returned error = %d\n", errno);
803            exit(0);
804        }
805        return;
806    }
807    EOF
808        make genmake_tc_1.o >> genmake_warnings 2>&1
809        RET_C=$?
810        cat <<EOF > genmake_tc_2.$FS
811          program hello
812          integer anint
813          common /iv/ anint
814          external sigreg
815          call sigreg(anint)
816          end
817    EOF
818        echo >> genmake_warnings
819        echo "running: check_HAVE_SIGREG()" >> genmake_warnings
820        cat genmake_tc_2.$FS >> genmake_warnings
821        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
822        echo $COMM >> genmake_warnings
823        $COMM >> genmake_warnings 2>&1
824        RETVAL=$?
825        if test "x$RETVAL" = x0 ; then
826            HAVE_SIGREG=t
827            DEFINES="$DEFINES -DHAVE_SIGREG"
828        fi
829        rm -f genmake_tc*
830    }
831    
832    
833    check_HAVE_SETRLSTK()  {
834        if test "x$HAVE_SETRLSTK" = xt ; then
835            DEFINES="$DEFINES -DHAVE_SETRLSTK"
836            return
837        fi  
838        if test ! "x$HAVE_SETRLSTK" = x ; then
839            return
840        fi
841        get_fortran_c_namemangling
842        cat <<EOF > genmake_tc_1.c
843    $FC_NAMEMANGLE
844    #include <sys/time.h>
845    #include <sys/resource.h>
846    #include <unistd.h>
847    void FC_NAMEMANGLE(setrlstk) ()
848    {
849        struct rlimit rls;
850        rls.rlim_cur = RLIM_INFINITY;
851        rls.rlim_max = RLIM_INFINITY;
852        setrlimit(RLIMIT_STACK, &rls);
853        return;
854    }
855    EOF
856        make genmake_tc_1.o >> genmake_warnings 2>&1
857        RET_C=$?
858        cat <<EOF > genmake_tc_2.$FS
859          program hello
860          external setrlstk
861          call setrlstk()
862          end
863    EOF
864        echo >> genmake_warnings
865        echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
866        cat genmake_tc_2.$FS >> genmake_warnings
867        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
868        echo $COMM >> genmake_warnings
869        $COMM >> genmake_warnings 2>&1
870        RETVAL=$?
871        if test "x$RETVAL" = x0 ; then
872            HAVE_SETRLSTK=t
873            DEFINES="$DEFINES -DHAVE_SETRLSTK"
874        fi
875        rm -f genmake_tc*
876    }
877    
878    
879  check_HAVE_STAT()  {  check_HAVE_STAT()  {
880      get_fortran_c_namemangling      get_fortran_c_namemangling
881      cat <<EOF > genmake_tc_1.c      cat <<EOF > genmake_tc_1.c
# Line 698  void FC_NAMEMANGLE(tfsize) ( int *nbyte Line 899  void FC_NAMEMANGLE(tfsize) ( int *nbyte
899  EOF  EOF
900      make genmake_tc_1.o >> genmake_tc.log 2>&1      make genmake_tc_1.o >> genmake_tc.log 2>&1
901      RET_C=$?      RET_C=$?
902      cat <<EOF > genmake_tc_2.f      cat <<EOF > genmake_tc_2.$FS
903        program hello        program hello
904        integer nbyte        integer nbyte
905        call tfsize(nbyte)        call tfsize(nbyte)
906        print *," HELLO WORLD", nbyte        print *," HELLO WORLD", nbyte
907        end program hello        end
908  EOF  EOF
909      $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1      echo >> genmake_warnings
910      RET_F=$?      echo "running: check_HAVE_STAT()" >> genmake_warnings
911      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      cat genmake_tc_2.$FS >> genmake_warnings
912        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
913        echo $COMM >> genmake_warnings
914        $COMM >> genmake_tc.log 2>&1
915      RETVAL=$?      RETVAL=$?
916      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
917          HAVE_STAT=t          HAVE_STAT=t
# Line 721  check_netcdf_libs()  { Line 925  check_netcdf_libs()  {
925      if test ! "x$SKIP_NETCDF_CHECK" = x ; then      if test ! "x$SKIP_NETCDF_CHECK" = x ; then
926          return          return
927      fi      fi
928      echo "" > genmake_tnc.log      echo >> genmake_warnings
929      cat <<EOF > genmake_tnc.for      echo "running: check_netcdf_libs()" >> genmake_warnings
930        cat <<EOF > genmake_tnc.F
931        program fgennc        program fgennc
932  #include "netcdf.inc"  #include "netcdf.inc"
933  EOF  EOF
934      if test ! "x$MPI" = x ; then      if test ! "x$MPI" = x ; then
935          echo '#include "mpif.h"' >> genmake_tnc.for          echo '#include "mpif.h"' >> genmake_tnc.F
936      fi      fi
937      cat <<EOF >> genmake_tnc.for      cat <<EOF >> genmake_tnc.F
938        integer iret, ncid, xid        integer iret, ncid, xid
939        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
940        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
# Line 739  EOF Line 944  EOF
944        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
945        end        end
946  EOF  EOF
947      echo "Executing:" > genmake_tnc.log      echo "===  genmake_tnc.F  ===" > genmake_tnc.log
948      echo "  $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f" \      cat genmake_tnc.F >> genmake_tnc.log
949          > genmake_tnc.log      echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
950      RET_CPP=f      RET_CPP=f
951      $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \      COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
952          &&  RET_CPP=t      echo "$COMM" >> genmake_tnc.log
953        eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
954      if test "x$RET_CPP" = xf ; then      if test "x$RET_CPP" = xf ; then
955          echo "  WARNING: CPP failed to pre-process the netcdf test." \          echo "  WARNING: CPP failed to pre-process the netcdf test." \
956              > genmake_tnc.log              >> genmake_tnc.log
957          echo "    Please check that \$INCLUDES is properly set." \          echo "    Please check that \$INCLUDES is properly set." \
958              > genmake_tnc.log              >> genmake_tnc.log
959      fi      fi
960      echo "Executing:" > genmake_tnc.log      echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
961      echo "  $FC $FFLAGS $FOPTIM -c genmake_tnc.f" > genmake_tnc.log      echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
962      echo "  $LINK -o genmake_tnc.o $LIBS" > genmake_tnc.log      $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
963      $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \          &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
         &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1  
964      RET_COMPILE=$?      RET_COMPILE=$?
965        cat genmake_tnc.log >> genmake_warnings
966    
967      #EH3  Remove test program execution for machines that either disallow      #EH3  Remove test program execution for machines that either disallow
968      #EH3  execution or cannot support it (eg. cross-compilers)      #EH3  execution or cannot support it (eg. cross-compilers)
# Line 769  EOF Line 975  EOF
975          HAVE_NETCDF=t          HAVE_NETCDF=t
976      else      else
977          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
978          $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \          echo "try again with added '-lnetcdf'" > genmake_tnc.log
979              &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f >> genmake_tnc.log 2>&1  \          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
980              &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
981            echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
982            cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
983                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
984                &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
985          RET_COMPILE=$?          RET_COMPILE=$?
986            cat genmake_tnc.log >> genmake_warnings
987          if test "x$RET_COMPILE" = x0 ; then          if test "x$RET_COMPILE" = x0 ; then
988              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
989              HAVE_NETCDF=t              HAVE_NETCDF=t
990          else          else
991            # try again with "-lnetcdff" added to the libs
992                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
993                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
994                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
995                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
996                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
997                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
998                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
999                RET_COMPILE=$?
1000              cat genmake_tnc.log >> genmake_warnings              cat genmake_tnc.log >> genmake_warnings
1001                if test "x$RET_COMPILE" = x0 ; then
1002                    LIBS="$LIBS -lnetcdff -lnetcdf"
1003                    HAVE_NETCDF=t
1004                fi
1005          fi          fi
1006      fi      fi
1007      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 804  DEFINES= Line 1028  DEFINES=
1028  PACKAGES=  PACKAGES=
1029  ENABLE=  ENABLE=
1030  DISABLE=  DISABLE=
1031  MAKEFILE=  # MAKEFILE=
1032  #MAKEDEPEND=  # MAKEDEPEND=
1033  PDEPEND=  PDEPEND=
1034  DUMPSTATE=t  DUMPSTATE=t
1035  PDEFAULT=  PDEFAULT=
# Line 813  OPTFILE= Line 1037  OPTFILE=
1037  INCLUDES="-I. $INCLUDES"  INCLUDES="-I. $INCLUDES"
1038  FFLAGS=  FFLAGS=
1039  FOPTIM=  FOPTIM=
1040    FEXTRAFLAGS=
1041  CFLAGS=  CFLAGS=
1042  KFLAGS1=  KFLAGS1=
1043  KFLAGS2=  KFLAGS2=
# Line 823  NOOPTFILES= Line 1048  NOOPTFILES=
1048  NOOPTFLAGS=  NOOPTFLAGS=
1049  MPI=  MPI=
1050  MPIPATH=  MPIPATH=
1051    TS=
1052    PAPIS=
1053    PCLS=
1054    FOOLAD=
1055    PAPI=
1056    PCL=
1057    HPMT=
1058    GSL=
1059    DEVEL=
1060    HAVE_TEST_L=
1061    
1062  # DEFINES checked by test compilation  # DEFINES checked by test compilation or command-line
1063  HAVE_SYSTEM=  HAVE_SYSTEM=
1064  HAVE_FDATE=  HAVE_FDATE=
1065  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1066  HAVE_CLOC=  HAVE_CLOC=
1067    # HAVE_SETRLSTK=
1068  HAVE_STAT=  HAVE_STAT=
1069  HAVE_NETCDF=  HAVE_NETCDF=
1070  HAVE_ETIME=  HAVE_ETIME=
1071    IGNORE_TIME=
1072    
1073  MODS=  MODS=
1074  TOOLSDIR=  TOOLSDIR=
# Line 844  BASH= Line 1081  BASH=
1081  PWD=`pwd`  PWD=`pwd`
1082  test "x$MAKE" = x  &&  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1083  test "x$AWK" = x   &&  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1084    EMBED_SRC=
1085  THISHOST=`hostname`  THISHOST=`hostname`
1086  THISCWD=`pwd`  THISCWD=`pwd`
1087  THISDATE=`date`  THISDATE=`date`
# Line 877  TAMC_EXTRA= Line 1115  TAMC_EXTRA=
1115    
1116  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1117  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1118  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1119    
1120  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1121  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1122  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1123  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1124  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
# Line 1057  for ac_option in "$@" ; do Line 1295  for ac_option in "$@" ; do
1295          -noieee | --noieee)          -noieee | --noieee)
1296              IEEE= ;;              IEEE= ;;
1297    
1298            -ts | --ts)
1299                TS=true ;;
1300            -papis | --papis)
1301                PAPIS=true ;;
1302            -pcls | --pcls)
1303                PCLS=true ;;
1304            -foolad | --foolad)
1305                FOOLAD=true ;;
1306            -papi | --papi)
1307                PAPI=true ;;
1308            -pcl | --pcl)
1309                PCL=true ;;
1310            -hpmt | --hpmt)
1311                HPMT=true ;;
1312    
1313            -gsl | --gsl)
1314                GSL=true ;;
1315    
1316            -devel | --devel)
1317                DEVEL=true ;;
1318    
1319          -mpi | --mpi)          -mpi | --mpi)
1320              MPI=true ;;              MPI=true ;;
1321          -mpi=* | --mpi=*)          -mpi=* | --mpi=*)
# Line 1080  for ac_option in "$@" ; do Line 1339  for ac_option in "$@" ; do
1339              ac_prev=TAMC_EXTRA ;;              ac_prev=TAMC_EXTRA ;;
1340          -tamc_extra=* | --tamc_extra=*)          -tamc_extra=* | --tamc_extra=*)
1341              TAMC_EXTRA=$ac_optarg ;;              TAMC_EXTRA=$ac_optarg ;;
1342            
1343            -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1344                IGNORE_TIME="-DIGNORE_TIME" ;;
1345    
1346            -es | --es | -embed-source | --embed-source)
1347                EMBED_SRC=t ;;
1348    
1349          -*)          -*)
1350              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
# Line 1095  for ac_option in "$@" ; do Line 1360  for ac_option in "$@" ; do
1360            
1361  done  done
1362    
1363    
1364  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1365      echo      echo
1366      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1367      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1368      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1369      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1370      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1371      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1372      echo      echo
1373  fi  fi
1374    
1375  #  Find the MITgcm ${ROOTDIR}  #  Find the MITgcm ${ROOTDIR}
1376  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1377      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1378      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1379          ROOTDIR=".."          ROOTDIR=".."
1380      else      else
1381          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 1136  fi Line 1401  fi
1401    
1402  #  Find the MITgcm ${THISVER}  #  Find the MITgcm ${THISVER}
1403  if test -f "${ROOTDIR}/doc/tag-index" ; then  if test -f "${ROOTDIR}/doc/tag-index" ; then
1404      THISVER=`grep checkpoint ${ROOTDIR}/doc/tag-index | head -1`      THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`
1405    fi
1406    
1407    if test "x$MAKEFILE" = x ; then
1408        MAKEFILE="Makefile"
1409  fi  fi
1410    
1411  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
# Line 1168  if test "x$OPTFILE" != xNONE ; then Line 1437  if test "x$OPTFILE" != xNONE ; then
1437      fi      fi
1438  fi  fi
1439    
 #  Check for broken systems that cannot correctly distinguish *.F and *.f files  
 # check_for_broken_Ff  
   
1440  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1441  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1442      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 1198  if test "x${AD_OPTFILE}" != xNONE ; then Line 1464  if test "x${AD_OPTFILE}" != xNONE ; then
1464      fi      fi
1465  fi  fi
1466    
1467    #====================================================================
1468    #  Set default values if not set by the optfile
1469    #
1470  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1471  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1472  if test ! "x$BASH" = x ; then  if test ! "x$BASH" = x ; then
# Line 1274  Error: The command "ln -s" failed -- ple Line 1543  Error: The command "ln -s" failed -- ple
1543  EOF  EOF
1544      exit 1      exit 1
1545  fi  fi
1546    test -L genmake_tlink > /dev/null 2>&1
1547    RETVAL=$?
1548    if test "x$RETVAL" = x0 ; then
1549        HAVE_TEST_L=t
1550    fi
1551  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1552    
1553  #  Check for broken *.F/*.f handling and fix if possible  #  Check for broken *.F/*.f handling and fix if possible
# Line 1284  if test ! "x$MPI" = x ; then Line 1558  if test ! "x$MPI" = x ; then
1558        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1559  fi  fi
1560    
1561    if test ! "x$TS" = x ; then
1562          echo "  Turning on timing per timestep"
1563          if test ! "x$FOOLAD" = x ; then
1564                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1565          else
1566                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1567          fi
1568          PACKAGES="$PACKAGES showflops"
1569    fi
1570    if test ! "x$PAPIS" = x ; then
1571          echo "  Turning on PAPI flop summary per timestep"
1572          echo "  Please make sure PAPIINC, PAPILIB are defined"
1573          if test ! "x$FOOLAD" = x ; then
1574                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1575          else
1576                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1577          fi
1578          INCLUDES="$INCLUDES $PAPIINC"
1579          LIBS="$LIBS $PAPILIB"
1580          PACKAGES="$PACKAGES showflops"
1581    fi
1582    if test ! "x$PCLS" = x ; then
1583          echo "  Turning on PCL counter summary per timestep"
1584          echo "  Please make sure PCLINC, PCLLIB are defined"
1585          if test ! "x$FOOLAD" = x ; then
1586                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1587          else
1588                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1589          fi
1590          INCLUDES="$INCLUDES $PCLINC"
1591          LIBS="$LIBS $PCLLIB"
1592          PACKAGES="$PACKAGES showflops"
1593    fi
1594    if test ! "x$PAPI" = x ; then
1595          if test ! "x$PAPIS" = x ; then
1596              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1597              echo "  Sticking with PAPI flop summary per timestep!"
1598          else
1599              echo "  Turning on performance analysis with PAPI"
1600              echo "  Please make sure PAPIINC, PAPILIB are defined"
1601              DEFINES="$DEFINES -DUSE_PAPI"
1602              INCLUDES="$INCLUDES $PAPIINC"
1603              LIBS="$LIBS $PAPILIB"
1604          fi
1605    fi
1606    if test ! "x$PCL" = x ; then
1607          if test ! "x$PCLS" = x ; then
1608              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1609              echo "  Sticking with PCL flop summary per timestep!"
1610          else
1611              echo "  Turning on performance analysis with PCL"
1612              echo "  Please make sure PCLINC, PCLLIB are defined"
1613              DEFINES="$DEFINES -DUSE_PCL"
1614              INCLUDES="$INCLUDES $PCLINC"
1615              LIBS="$LIBS $PCLLIB"
1616          fi
1617    fi
1618    if test ! "x$HPMT" = x ; then
1619          if test ! "x$PAPI" = x ; then
1620              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1621              echo "  Sticking with PAPI!"
1622          else if test ! "x$PCL" = x ; then
1623              echo "  PCL and the HPM Toolkit cannot co-exist!"
1624              echo "  Sticking with PCL!"
1625          else
1626              echo "  Turning on performance analysis with the HPM Toolkit"
1627              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1628              DEFINES="$DEFINES -DUSE_LIBHPM"
1629              INCLUDES="$INCLUDES $HPMTINC"
1630              LIBS="$LIBS $HPMTLIB"
1631          fi
1632          fi
1633    fi
1634    if test ! "x$GSL" = x ; then
1635          echo "  Turning on use of GSL to control floating point calculations"
1636          echo "  Please make sure GSLINC, GSLLIB are defined"
1637          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1638          INCLUDES="$INCLUDES $GSLINC"
1639          LIBS="$LIBS $GSLLIB"
1640    fi
1641    
1642  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1643  printf "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1644  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1645        program hello        program hello
1646        call system('echo hi')        call system('echo hi')
1647        end        end
1648  EOF  EOF
1649  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1650  RETVAL=$?  RETVAL=$?
1651  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1652      HAVE_SYSTEM=t      HAVE_SYSTEM=t
# Line 1304  fi Line 1659  fi
1659  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1660    
1661  printf "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1662  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1663        program hello        program hello
1664        CHARACTER(128) string        CHARACTER*(128) string
1665        string = ' '        string = ' '
1666        call fdate( string )        call fdate( string )
1667        print *, string        print *, string
1668        end        end
1669  EOF  EOF
1670  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1671  RETVAL=$?  RETVAL=$?
1672  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1673      HAVE_FDATE=t      HAVE_FDATE=t
# Line 1325  fi Line 1680  fi
1680  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1681    
1682  printf "  Do we have the etime() command using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1683  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1684        program hello        program hello
1685        REAL*4 ACTUAL, TARRAY(2)        REAL*4 ACTUAL, TARRAY(2)
1686        EXTERNAL ETIME        EXTERNAL ETIME
# Line 1334  cat > genmake_tcomp.f <<EOF Line 1689  cat > genmake_tcomp.f <<EOF
1689        print *, tarray        print *, tarray
1690        end        end
1691  EOF  EOF
1692  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1693  RETVAL=$?  RETVAL=$?
1694  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1695      HAVE_ETIME=t      HAVE_ETIME=t
# Line 1352  if test "x$HAVE_CLOC" != x ; then Line 1707  if test "x$HAVE_CLOC" != x ; then
1707      echo "yes"      echo "yes"
1708  else  else
1709      echo "no"      echo "no"
1710        if test "x$EMBED_SRC" = xt ; then
1711            echo "    WARNING: you requested file embedding but it has"
1712            echo "      been disabled since C code cannot be called"
1713            EMBED_SRC=
1714        fi
1715    fi
1716    rm -f genmake_t*
1717    
1718    printf "  Can we unlimit the stack size using $FC...  "
1719    check_HAVE_SETRLSTK
1720    if test "x$HAVE_SETRLSTK" = xt ; then
1721        echo "yes"
1722    else
1723        echo "no"
1724    fi
1725    rm -f genmake_t*
1726    
1727    printf "  Can we register a signal handler using $FC...  "
1728    check_HAVE_SIGREG
1729    if test "x$HAVE_SIGREG" = xt ; then
1730        echo "yes"
1731    else
1732        echo "no"
1733  fi  fi
1734  rm -f genmake_t*  rm -f genmake_t*
1735    
# Line 1371  if test "x$HAVE_NETCDF" != x ; then Line 1749  if test "x$HAVE_NETCDF" != x ; then
1749  else  else
1750      echo "no"      echo "no"
1751  fi  fi
1752    DEFINES="$DEFINES $IGNORE_TIME"
1753    
1754    if test "x$EMBED_SRC" = xt ; then
1755        build_embed_encode
1756    fi
1757    if test "x$EMBED_SRC" = xt ; then
1758        ENABLE="$ENABLE embed_files"
1759    fi
1760    
1761    
1762  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
# Line 1388  for d in $MODS ; do Line 1774  for d in $MODS ; do
1774  done  done
1775  echo  echo
1776    
 if test "x$MAKEFILE" = x ; then  
     MAKEFILE="Makefile"  
 fi  
1777  if test "x${PLATFORM}" = x ; then  if test "x${PLATFORM}" = x ; then
1778      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
1779  fi  fi
# Line 1461  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1844  if test -r $ROOTDIR"/eesupp/src/Makefile
1844      fi      fi
1845  fi  fi
1846    
1847  #same for exch2  #same for pkg/exch2 and pkg/regrid
1848  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1849      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1850      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1851      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1852      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1853          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1854      else              rm -f make_${pdir}.errors
1855          echo "Error: problem encountered while building source files in exch2:"          else
1856          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1857          exit 1              cat make_${pdir}.errors 1>&2
1858                exit 1
1859            fi
1860      fi      fi
1861  fi  done
1862    
1863  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1864  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1584  done Line 1969  done
1969  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1970  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1971    
1972  #  Check availability of NetCDF and then either build the MNC template  #  Check for package MNC: if NetCDF is available, then build the MNC
1973  #  files or delete mnc from the list of available packages.  #  template files ; otherwise, delete mnc from the list of packages.
1974  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1975  RETVAL=$?  RETVAL=$?
1976  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
# Line 1619  EOF Line 2004  EOF
2004      fi      fi
2005  fi  fi
2006    
2007    #  Check for package PROFILES: if NetCDF is not available,
2008    #  then delete profiles from the list of available packages.
2009    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2010    RETVAL=$?
2011    if test "x$RETVAL" = x0 ; then
2012        if test "x$HAVE_NETCDF" != xt ; then
2013            cat <<EOF
2014    
2015    *********************************************************************
2016    WARNING: the "profiles" package was enabled but tests failed to
2017      compile NetCDF applications.  Please check that:
2018    
2019      1) NetCDF is correctly installed for this compiler and
2020      2) the LIBS variable (within the "optfile") specifies the correct
2021           NetCDF library to link against.
2022    
2023      Due to this failure, the "profiles" package is now DISABLED.
2024    *********************************************************************
2025    
2026    EOF
2027            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2028            DISABLE="$DISABLE profiles"
2029        fi
2030    fi
2031    
2032  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2033  ck=  ck=
2034  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2035      i=0      i=0
2036      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2037      rtot=$nname      rtot=$nname
2038      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2039    
2040          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2041          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1659  while test "x$ck" != xtt ; do Line 2069  while test "x$ck" != xtt ; do
2069    
2070          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2071          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2072                #echo "   " $pname ": need to add :" $dname
2073              in_dis="f"              in_dis="f"
2074              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2075                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 1813  for i in $SOURCEDIRS ; do Line 2224  for i in $SOURCEDIRS ; do
2224          cat $i/$j >> ad_files          cat $i/$j >> ad_files
2225      done      done
2226  done  done
2227    if test ! "x"$FS = "x.f" ; then
2228        cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f
2229        mv -f ad_files_f ad_files
2230    fi
2231    
2232  echo  echo
2233  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1824  for i in $INCLUDEDIRS ; do Line 2238  for i in $INCLUDEDIRS ; do
2238      fi      fi
2239  done  done
2240    
2241    if test ! "x$DIVA" = x ; then
2242        echo "  Creating the pseudo-MPI include directory"
2243        INCLUDES="-I./mpi_headers $INCLUDES"
2244        rm -rf ./mpi_headers
2245        mkdir -p ./mpi_headers
2246    
2247        if test "x$MPIINCLUDEDIR" = x ; then
2248            if test "x$MPIHOME" = x ; then
2249                MPIHOME='/usr'
2250            fi
2251            MPIINCLUDEDIR='$MPIHOME/include'
2252        fi
2253        
2254        if test -r $MPIINCLUDEDIR/mpif.h ; then
2255            for i in $MPI_HEADER_FILES; do
2256                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2257            done
2258    
2259            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2260        else
2261            echo " We cannot create a copy of mpif.h!"
2262    #       exit -1
2263        fi
2264    fi
2265    
2266  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2267  rm -rf .links.tmp  rm -rf .links.tmp
2268  mkdir .links.tmp  mkdir .links.tmp
2269    touch .links.tmp/foo
2270    if test ! -r ".links.tmp/foo" ; then
2271        echo
2272        echo "ERROR : something is wrong with your directory permissions or"
2273        echo "   your user file-creation mask (\"umask\") since creating a"
2274        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2275        echo "   not working.  Please try setting your umask to something"
2276        echo "   sane such as:"
2277        echo
2278        echo "      umask 0002"
2279        echo
2280        echo "   and please verify that you have the proper permissions for"
2281        echo "   creating sub-directories and then reading files created"
2282        echo "   within them."
2283        echo
2284        exit 1
2285    fi
2286    rm -f .links.tmp/foo
2287  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2288  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2289  printf 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
# Line 1842  for d in $alldirs ; do Line 2299  for d in $alldirs ; do
2299      for sf in $sfiles ; do      for sf in $sfiles ; do
2300          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2301              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2302                    ignore_f=f
2303                  case $d/$sf in                  case $d/$sf in
2304                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2305                            ignore_f=t
2306                          ;;                          ;;
2307                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2308                            ignore_f=t
2309                          ;;                          ;;
2310                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2311                            ignore_f=t
2312                          ;;                          ;;
2313                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2314                            ignore_f=t
2315                            ;;
2316                      ./EMBEDDED_FILES.h)
2317                            ignore_f=t
2318                          ;;                          ;;
2319                    *)                    *)
2320                          touch .links.tmp/$sf                          #  For the local directory *ONLY*,
2321                          deplist="$deplist $sf"                          #  ignore all soft-links
2322                            if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2323                                ignore_f=t
2324                            else
2325                                touch .links.tmp/$sf
2326                                deplist="$deplist $sf"
2327                            fi
2328                          ;;                          ;;
2329                  esac                  esac
2330                  extn=`echo $sf | $AWK -F. '{print $NF}'`                  if test "x$ignore_f" = xf ; then
2331                  case $extn in                      extn=`echo $sf | $AWK -F. '{print $NF}'`
2332                      F)                      case $extn in
2333                          echo    " \\"  >> srclist.inc                          F)
2334                          printf " $sf" >> srclist.inc                              echo    " \\"  >> srclist.inc
2335                          ;;                              printf " $sf" >> srclist.inc
2336                      F90)                              ;;
2337                          echo    " \\"  >> f90srclist.inc                          F90)
2338                          printf " $sf" >> f90srclist.inc                              echo    " \\"  >> f90srclist.inc
2339                          ;;                              printf " $sf" >> f90srclist.inc
2340                      c)                              ;;
2341                          echo    " \\"  >> csrclist.inc                          c)
2342                          printf " $sf" >> csrclist.inc                              echo    " \\"  >> csrclist.inc
2343                          ;;                              printf " $sf" >> csrclist.inc
2344                      h)                              ;;
2345                          echo    " \\"  >> hlist.inc                          h)
2346                          printf " $sf" >> hlist.inc                              echo    " \\"  >> hlist.inc
2347                          ;;                              printf " $sf" >> hlist.inc
2348                      flow)                              ;;
2349                          echo    " \\"  >> ad_flow_files.inc                          flow)
2350                          printf " $sf" >> ad_flow_files.inc                              echo    " \\"  >> ad_flow_files.inc
2351                          ;;                              printf " $sf" >> ad_flow_files.inc
2352                  esac                              ;;
2353                        esac
2354                    fi
2355              fi              fi
2356          fi          fi
2357      done      done
# Line 1954  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2427  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2427    
2428  # These files are created by Makefile  # These files are created by Makefile
2429  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2430  EOF  EOF
2431    
2432  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2433        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2434    else
2435        echo "EMBEDDED_FILES = " >>$MAKEFILE
2436    fi
2437    
2438    #  Note: figure out some way to add Hyades JAM libraries here
2439  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2440  # Unix ln (link)  # Unix ln (link)
2441  LN = ${LN}  LN = ${LN}
# Line 1985  INCLUDES = ${INCLUDES} Line 2462  INCLUDES = ${INCLUDES}
2462  KFLAGS1 = ${KFLAGS1}  KFLAGS1 = ${KFLAGS1}
2463  KFLAGS2 = ${KFLAGS2}  KFLAGS2 = ${KFLAGS2}
2464  # Optim./debug for FC  # Optim./debug for FC
2465  FFLAGS = ${FFLAGS}  FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2466  FOPTIM = ${FOPTIM}  FOPTIM = ${FOPTIM}
2467  # Optim./debug for FC  # Optim./debug for FC
2468  F90FLAGS = ${F90FLAGS}  F90FLAGS = ${F90FLAGS}
# Line 2009  cat hlist.inc         >> $MAKEFILE Line 2486  cat hlist.inc         >> $MAKEFILE
2486  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2487  echo >> $MAKEFILE  echo >> $MAKEFILE
2488  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2489  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2490  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2491  echo >> $MAKEFILE  echo >> $MAKEFILE
2492  echo '.SUFFIXES:' >> $MAKEFILE  echo '.SUFFIXES:' >> $MAKEFILE
# Line 2020  rm -f ad_flow_files.inc Line 2497  rm -f ad_flow_files.inc
2497  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2498    
2499  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2500  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2501          @echo Creating \$@ ...          @echo Creating \$@ ...
2502          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2503  depend:  depend:
# Line 2029  depend: Line 2506  depend:
2506          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2507          -rm -f makedepend.out          -rm -f makedepend.out
2508    
2509    lib: libmitgcmuv.a
2510    
2511    libmitgcmuv.a: \$(OBJFILES)
2512            ar rcv libmitgcmuv.a \$(OBJFILES)
2513            ar d   libmitgcmuv.a main.o
2514    
2515  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2516    
2517  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
# Line 2038  output.txt: \$(EXECUTABLE) Line 2521  output.txt: \$(EXECUTABLE)
2521          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2522    
2523  clean:  clean:
2524          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2525            -rm -rf *.o
2526            -rm -rf *.$FS
2527  Clean:  Clean:
2528          @make clean          @make clean
2529          @make cleanlinks          @make cleanlinks
2530          -rm -f \$(SPECIAL_FILES)          -rm -f \$(SPECIAL_FILES)
2531          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
2532            -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2533  CLEAN:  CLEAN:
2534          @make Clean          @make Clean
2535          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2536          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2537          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2538          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2539            -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2540            -rm -rf mnc_test_*
2541    
2542  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2543  makefile:  makefile:
# Line 2077  test ! "x$THISUSER" = x && echo "      -echo Line 2565  test ! "x$THISUSER" = x && echo "      -echo
2565  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2566  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2567    
2568    if test "x$EMBED_SRC" = xt ; then
2569        cat >>$MAKEFILE <<EOF
2570    
2571    decode_files.o : EMBEDDED_FILES.h
2572    
2573    ##  \$(F77FILES)
2574    all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2575            @echo Creating \$@ ...
2576            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2577            -rm -f all_fF.tar.gz
2578            -gzip all_fF.tar
2579    
2580    EMBEDDED_FILES.h : all_fF.tar.gz
2581            @echo Creating \$@ ...
2582            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2583    
2584    EOF
2585    fi
2586    
2587  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2588    
2589  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2088  cat >>$MAKEFILE <<EOF Line 2595  cat >>$MAKEFILE <<EOF
2595          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2596  .$FS.o:  .$FS.o:
2597          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2598  .F90.$FS90:  .F90.o:  
         \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@  
 .$FS90.o:  
2599          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2600  .c.o:  .c.o:
2601          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2602    
2603  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2604  .F.p:  .F.p:
# Line 2117  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2622  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2622  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2623  for i in $ad_vars ; do  for i in $ad_vars ; do
2624      name=$i      name=$i
2625      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2626      eval $t1      eval $t1
2627      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2628      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2629  done  done
2630    
2631  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
# Line 2137  rm -f ad_files Line 2642  rm -f ad_files
2642  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2643    
2644  # ... AD ...  # ... AD ...
2645  adall: ad_taf  adall: \$(EXE_AD)
2646  adtaf: ad_taf_output.f  adtaf: ad_taf_output.$FS
2647  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.$FS
2648    
2649  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2650          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2651          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2652          -rm -f ad_config.template          -rm -f ad_config.template
2653          @make \$(F77FILES)          @make \$(F77FILES)
2654          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2655          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS
2656    
2657  ad_taf_output.f: ad_input_code.f  ad_taf_output.$FS: ad_input_code.$FS
2658          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2659          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2660    
2661  adtafonly:  adtafonly:
2662          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2663          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2664    
2665  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2666          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2667    
2668  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.$FS: ad_input_code.$FS
2669          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2670          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2671    
2672  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2673          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 2175  adtrick: Line 2680  adtrick:
2680    
2681  # ... FTL ...  # ... FTL ...
2682  ftlall: ftl_taf  ftlall: ftl_taf
2683  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.$FS
2684  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.$FS
2685    
2686  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2687          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2688          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2689          -rm -f ftl_config.template          -rm -f ftl_config.template
2690          @make \$(F77FILES)          @make \$(F77FILES)
2691          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2692          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2693    
2694  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.$FS: ftl_input_code.$FS
2695          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2696          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2697    
2698  ftltafonly:  ftltafonly:
2699          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2700          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2701    
2702  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
2703          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2704    
2705  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.$FS: ftl_input_code.$FS
2706          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2707          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2708    
2709  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2710          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2711    
2712    
2713  # ... SVD ...  # ... SVD ...
2714  svdtaf: ad_taf_output.f ftl_taf_output.f  svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2715          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2716          @echo "--->>> Do make svdall afterwards to compile. <<<---"          @echo "--->>> Do make svdall afterwards to compile. <<<---"
2717  svdall: svd_touch svd_taf  svdall: svd_touch svd_taf
# Line 2222  svd_touch: Line 2727  svd_touch:
2727          @echo "--->>> Only COMPILE svd code! <<<---"          @echo "--->>> Only COMPILE svd code! <<<---"
2728          @echo "--->>> Assumes you previously <<<---"          @echo "--->>> Assumes you previously <<<---"
2729          @echo "--->>> did make svdtaf        <<<---"          @echo "--->>> did make svdtaf        <<<---"
2730          touch ad_taf_output.f ftl_taf_output.f          touch ad_taf_output.$FS ftl_taf_output.$FS
2731          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.f          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2732          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.f          \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2733          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2734          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2735          -rm -f ftl_config.template          -rm -f ftl_config.template

Legend:
Removed from v.1.116  
changed lines
  Added in v.1.166

  ViewVC Help
Powered by ViewVC 1.1.22